# This module is part of the Quotient project and is Copyright 2003 Divmod:
# http://www.divmod.org/.  This is free software.  You can redistribute it
# and/or modify it under the terms of version 2.1 of the GNU Lesser General
# Public License as published by the Free Software Foundation.

from formless.annotate import *
from formless.processors import process


# BACK COMPAT: import (with deprecation warnings) the interfaces that
# were once in nevow.formless
import sys
import types
import warnings

from twisted.python import reflect

class ModuleWithDeprecations(types.ModuleType):

    def __init__(self, original, deprecations):
        """original is the original module (get it from sys.modules),
        deprecatedNames is a mapping of old to new name. The new name
        is a fully qualified name.
        """
        self.original = original
        self.deprecatedNames = {}
        for (module, names) in deprecations.iteritems():
            for n in names:
                assert n not in self.deprecatedNames
                self.deprecatedNames[n] = '%s.%s'%(module,n)
 
    def __getattr__(self, name):
        newName = self.deprecatedNames.get(name, None)
        if newName is not None:
            warnings.warn("formless.%s is deprecated, please import %s instead!"% (name,newName), DeprecationWarning, 2)
            return reflect.namedAny(newName)
        return getattr(self.original, name)

# Evil hack? What evil hack!
sys.modules['formless'] = ModuleWithDeprecations(
    sys.modules['formless'],
    {'formless.iformless':['IAutomaticConfigurable',
                           'IConfigurable',
                           'ITyped',
                           'IActionableType',
                           'IBinding'
                           ]
     }
    )
