# This module is part of the Quotient project and is Copyright 2003 Divmod:
# http://www.divmod.org/.  This is free software.  You can redistribute it
# and/or modify it under the terms of version 2.1 of the GNU Lesser General
# Public License as published by the Free Software Foundation.

from __future__ import generators

__version__ = "0.2a-pre"
import sys
from nevow import compy
from nevow.util import namedAny as na




def getAOI(fObj):
    for line in fObj:
        line = line.strip()
        if line and not line.startswith('#'):
            yield line.split()


# Python2.2 has a stupidity where instance methods have name
# '__builtin__.instance method' instead of '__builtin__.instancemethod'
# Workaround this error.
def load(S):
    for (a, o, i) in getAOI(S.split('\n')):
        if o == '__builtin__.instancemethod' and sys.version_info < (2,3):
            compy.registerAdapter(a, '__builtin__.instance method', i)
        else:
            compy.registerAdapter(a, o, i)


namespace = "http://nevow.com/ns/nevow/0.1"
'''The xml namespace of the nevow elements and attributes.'''


basic_adapters = """
nevow.formless.Group                   nevow.formless.MetaTypedInterface        nevow.formless.ITyped

nevow.accessors.DictionaryContainer    __builtin__.dict                         nevow.inevow.IContainer
nevow.accessors.ListContainer          __builtin__.list                         nevow.inevow.IContainer
nevow.accessors.ListContainer          __builtin__.tuple                        nevow.inevow.IContainer

nevow.accessors.FunctionAccessor       __builtin__.function                     nevow.inevow.IGettable
nevow.accessors.FunctionAccessor       __builtin__.method                       nevow.inevow.IGettable
nevow.accessors.FunctionAccessor       __builtin__.instancemethod               nevow.inevow.IGettable
nevow.accessors.DirectiveAccessor      nevow.stan.directive                     nevow.inevow.IGettable

nevow.flat.flatmdom.MicroDomDocumentSerializer          twisted.web.microdom.Document           nevow.inevow.ISerializable
nevow.flat.flatmdom.MicroDomTextSerializer              twisted.web.microdom.Text               nevow.inevow.ISerializable
nevow.flat.flatmdom.MicroDomCommentSerializer           twisted.web.microdom.Comment            nevow.inevow.ISerializable
nevow.flat.flatmdom.MicroDomElementSerializer           twisted.web.microdom.Element            nevow.inevow.ISerializable
nevow.flat.flatmdom.MicroDomEntityReferenceSerializer   twisted.web.microdom.EntityReference    nevow.inevow.ISerializable

nevow.flat.flatstan.ProtoSerializer               nevow.stan.Proto                  nevow.inevow.ISerializable
nevow.flat.flatstan.TagSerializer                 nevow.stan.Tag                    nevow.inevow.ISerializable
nevow.flat.flatstan.EntitySerializer                 nevow.stan.Entity                    nevow.inevow.ISerializable
nevow.flat.flatstan.CommentSerializer             nevow.stan.Comment                nevow.inevow.ISerializable
nevow.flat.flatstan.XmlSerializer                 nevow.stan.xml                    nevow.inevow.ISerializable
nevow.flat.flatstan.StringSerializer              __builtin__.str                   nevow.inevow.ISerializable
nevow.flat.flatstan.UTF8Serializer                __builtin__.unicode               nevow.inevow.ISerializable
nevow.flat.flatstan.NoneWarningSerializer         __builtin__.NoneType              nevow.inevow.ISerializable
nevow.flat.flatstan.StringCastSerializer          __builtin__.int                   nevow.inevow.ISerializable
nevow.flat.flatstan.StringCastSerializer          __builtin__.float                 nevow.inevow.ISerializable
nevow.flat.flatstan.StringCastSerializer          __builtin__.long                  nevow.inevow.ISerializable
nevow.flat.flatstan.StringCastSerializer          __builtin__.bool                  nevow.inevow.ISerializable
nevow.flat.flatstan.ListSerializer                __builtin__.list                  nevow.inevow.ISerializable
nevow.flat.flatstan.StringCastSerializer          __builtin__.dict                  nevow.inevow.ISerializable
nevow.flat.flatstan.ListSerializer                __builtin__.tuple                 nevow.inevow.ISerializable
nevow.flat.flatstan.ListSerializer                __builtin__.generator             nevow.inevow.ISerializable
nevow.flat.flatstan.FunctionSerializer            __builtin__.function              nevow.inevow.ISerializable
nevow.flat.flatstan.FunctionSerializer            __builtin__.type                  nevow.inevow.ISerializable
nevow.flat.flatstan.MethodSerializer              __builtin__.instancemethod        nevow.inevow.ISerializable
nevow.flat.flatstan.CallableInstanceSerializer    nevow.inevow.IRenderer            nevow.inevow.ISerializable
nevow.flat.flatstan.CallableInstanceSerializer    nevow.inevow.IRendererFactory     nevow.inevow.ISerializable
nevow.flat.flatstan.DirectiveSerializer           nevow.stan.directive              nevow.inevow.ISerializable
nevow.flat.flatstan.SlotSerializer                nevow.stan.slot                   nevow.inevow.ISerializable
nevow.flat.flatstan.ContextSerializer             nevow.context.WovenContext        nevow.inevow.ISerializable
nevow.flat.flatstan.DeferredSerializer            twisted.internet.defer.Deferred   nevow.inevow.ISerializable
nevow.flat.flatstan.DeferredSerializer            twisted.internet.defer.DeferredList   nevow.inevow.ISerializable

nevow.url.URLOverlaySerializer            nevow.url.URLOverlay     nevow.inevow.ISerializable
nevow.url.URLSerializer            nevow.url.URL     nevow.inevow.ISerializable
nevow.url.URLSerializer            nevow.url.URLPath     nevow.inevow.ISerializable

    # Itertools uses special types

nevow.flat.flatstan.ListSerializer  itertools.chain        nevow.inevow.ISerializable
nevow.flat.flatstan.ListSerializer  itertools.count        nevow.inevow.ISerializable
nevow.flat.flatstan.ListSerializer  itertools.cycle        nevow.inevow.ISerializable
nevow.flat.flatstan.ListSerializer  itertools.dropwhile    nevow.inevow.ISerializable
nevow.flat.flatstan.ListSerializer  itertools.ifilter      nevow.inevow.ISerializable
nevow.flat.flatstan.ListSerializer  itertools.ifilterfalse nevow.inevow.ISerializable
nevow.flat.flatstan.ListSerializer  itertools.imap         nevow.inevow.ISerializable
nevow.flat.flatstan.ListSerializer  itertools.islice       nevow.inevow.ISerializable
nevow.flat.flatstan.ListSerializer  itertools.izip         nevow.inevow.ISerializable
nevow.flat.flatstan.ListSerializer  itertools.repeat       nevow.inevow.ISerializable
nevow.flat.flatstan.ListSerializer  itertools.starmap      nevow.inevow.ISerializable
nevow.flat.flatstan.ListSerializer  itertools.takewhile    nevow.inevow.ISerializable

    #

formless.webform.PropertyBindingRenderer  formless.annotate.Property         formless.iformless.IBindingRenderer
formless.webform.MethodBindingRenderer    formless.annotate.MethodBinding    formless.iformless.IBindingRenderer
formless.webform.GroupBindingRenderer     formless.annotate.GroupBinding     formless.iformless.IBindingRenderer

    #

formless.webform.StringRenderer         formless.annotate.String         formless.iformless.ITypedRenderer
formless.webform.StringRenderer         formless.annotate.Integer        formless.iformless.ITypedRenderer
formless.webform.StringRenderer         formless.annotate.Directory      formless.iformless.ITypedRenderer
formless.webform.PasswordRenderer       formless.annotate.Password       formless.iformless.ITypedRenderer
formless.webform.PasswordEntryRenderer  formless.annotate.PasswordEntry  formless.iformless.ITypedRenderer
formless.webform.TextRenderer           formless.annotate.Text           formless.iformless.ITypedRenderer
formless.webform.BooleanRenderer        formless.annotate.Boolean        formless.iformless.ITypedRenderer
formless.webform.ChoiceRenderer         formless.annotate.Choice         formless.iformless.ITypedRenderer
formless.webform.ObjectRenderer         formless.annotate.Object         formless.iformless.ITypedRenderer
formless.webform.NullRenderer           formless.annotate.Request        formless.iformless.ITypedRenderer
formless.webform.NullRenderer           formless.annotate.Context        formless.iformless.ITypedRenderer
formless.webform.FileUploadRenderer     formless.annotate.FileUpload     formless.iformless.ITypedRenderer
formless.webform.ButtonRenderer         formless.annotate.Button         formless.iformless.ITypedRenderer

    #

formless.processors.ProcessGroupBinding    formless.annotate.GroupBinding     formless.iformless.IInputProcessor
formless.processors.ProcessMethodBinding   formless.annotate.MethodBinding    formless.iformless.IInputProcessor
formless.processors.ProcessPropertyBinding    formless.annotate.Property         formless.iformless.IInputProcessor
formless.processors.ProcessTyped           formless.iformless.ITyped           formless.iformless.IInputProcessor
formless.processors.ProcessPassword        formless.annotate.Password         formless.iformless.IInputProcessor
formless.processors.ProcessRequest         formless.annotate.Request          formless.iformless.IInputProcessor
formless.processors.ProcessContext         formless.annotate.Context          formless.iformless.IInputProcessor
formless.processors.ProcessUpload          formless.annotate.FileUpload       formless.iformless.IInputProcessor

    #

formless.webform.FormDefaults     nevow.appserver.NevowRequest                formless.iformless.IFormDefaults
formless.webform.FormDefaults     nevow.testutil.FakeRequest                  formless.iformless.IFormDefaults
formless.webform.FormDefaults     nevow.testutil.FakeSession                  formless.iformless.IFormDefaults
formless.webform.FormDefaults     twisted.web.server.Session                  formless.iformless.IFormDefaults
formless.webform.FormDefaults     twisted.web.woven.guard.GuardSession        formless.iformless.IFormDefaults
formless.webform.FormDefaults     nevow.guard.GuardSession                    formless.iformless.IFormDefaults

formless.webform.FormErrors       twisted.web.server.Session               formless.iformless.IFormErrors
formless.webform.FormErrors       twisted.web.woven.guard.GuardSession     formless.iformless.IFormErrors
formless.webform.FormErrors       nevow.guard.GuardSession                 formless.iformless.IFormErrors
formless.webform.FormErrors       nevow.testutil.FakeSession               formless.iformless.IFormErrors

nevow.appserver.OldResourceAdapter                  twisted.web.resource.IResource      nevow.inevow.IResource

nevow.formless.ListConfigurable __builtin__.list  nevow.formless.IConfigurable

nevow.flat.flatstan.DocFactorySerializer nevow.inevow.IDocFactory  nevow.inevow.ISerializable

nevow.appserver.sessionFactory  nevow.context.RequestContext    nevow.inevow.ISession
nevow.rend.handFactory   nevow.context.RequestContext    nevow.inevow.IHand
nevow.rend.statusFactory   nevow.context.RequestContext    nevow.inevow.IStatusMessage
nevow.rend.defaultsFactory   nevow.context.RequestContext    formless.iformless.IFormDefaults
nevow.rend.errorsFactory   nevow.context.RequestContext    formless.iformless.IFormErrors

nevow.rend.originalFactory  nevow.context.PageContext   nevow.inevow.IRenderer
nevow.rend.originalFactory  nevow.context.PageContext   nevow.inevow.IRendererFactory
nevow.rend.originalFactory  nevow.context.PageContext   nevow.inevow.IData
nevow.rend.originalFactory  nevow.context.PageContext   nevow.inevow.IConfigurableFactory

nevow.rend.PageGettable nevow.inevow.IResource nevow.inevow.IGettable

"""

load(basic_adapters)


# BACK COMPAT
# Import formless and freeform (now webform) into the nevow package.

import sys
import types
import warnings

from twisted.python import reflect

class ModuleWithDeprecations(types.ModuleType):

    def __init__(self, original, deprecatedNames):
        self.original = original
        self.deprecatedNames = deprecatedNames
 
    def __getattr__(self, name):
        newName = self.deprecatedNames.get(name, None)
        if newName is not None:
            warnings.warn("nevow.%s is deprecated, please import %s instead!"% (name,newName), DeprecationWarning, 2)
            return reflect.namedAny(newName)
        return getattr(self.original, name)

# Evil hack? What evil hack!
sys.modules['nevow'] = ModuleWithDeprecations(
    sys.modules['nevow'],
    {'formless': 'formless',
     'freeform': 'formless.webform'
     }
    )
