
import calendar
from datetime import date

from nevow import rend
from nevow.url import root
from nevow import tags as T


class DayDetail(rend.Page):
    def __init__(self, calendarEntries, year, month, date):
        self.calendarEntries = calendarEntries
        self.year = year
        self.month = month
        self.date = date
        super(DayDetail, self).__init__()

    def render_date(self, context, data):
        return "%s %s, %s" % (calendar.month_name[self.month], self.date, self.year)

    def render_events(self, context, data):
        events = self.calendarEntries.eventsFor(date(self.year, self.month, self.date))
        if not events: return "No events yet."
        return T.ol[[
            T.li[str(e)]
            for e in events
        ]]

    docFactory = rend.stan(
    T.html[
        T.head[
            T.title[
                "Detail for ", render_date]],
        T.body[
            T.a(href=root)["Back"],
            T.h1[
                "Detail for ", render_date],
            T.h2[
                "Events:"],
            render_events]])

